﻿<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class DemoAresSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';

    ///////////////////////////////////////////////////////////////////////

    public function __construct($tv)
    {
        parent::__construct(self::ID);
        $this->tv = $tv;
        $this->login = null;
        $this->profiles = null;
        $this->profile = null;
    }

    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();

        $show_tv = isset($plugin_cookies->show_tv) ? $plugin_cookies->show_tv : 'yes';
        //$show_vod = isset($plugin_cookies->show_vod) ? $plugin_cookies->show_vod : 'yes';
        $use_proxy = isset($plugin_cookies->use_proxy) ? $plugin_cookies->use_proxy : 'no';
        $proxy_ip = isset($plugin_cookies->proxy_ip) ? $plugin_cookies->proxy_ip : '192.168.0.1';
        $proxy_port = isset($plugin_cookies->proxy_port) ? $plugin_cookies->proxy_port : '8080';

        $this->add_label ($defs, 'iptvportal plugin:', DemoConfig::PLUGIN_VERSION);
        //$this->add_combobox ($defs, 'show_tv', 'iptvportal в разделе ТВ:', $show_tv, $show_ops, 0, true);
        if (DemoConfig::arescam_auth_mode === DemoConfig::AUTH_LOGIN_AND_REGISTER) {
            $this->add_button ($defs, 'register_button', null, 'Регистрация', 400);
        }

        $profiles = array();
        if ($this->profiles && $this->profile) {
            $init_profile = $this->profile->id;
            foreach ($this->profiles as $profile) {
                $profiles [$profile->id] = $profile->title;
            }
        } else {
            $init_profile = 1;
            $profiles [$init_profile] = '0+';
        }
        $this->add_combobox ($defs, 'profile', 'Профиль:', $init_profile, $profiles, 0, true);

        $show_ops = array();
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';
        $this->add_combobox ($defs, 'use_proxy', 'Использовать Proxy для UDP:', $use_proxy, $show_ops, 0, true);
        if ($use_proxy == 'yes') {
            $this->add_text_field ($defs, 'proxy_ip', 'Адрес proxy-сервера (IP или DNS):', $proxy_ip,
                                    false, false, false, true, 500, false, true);
            $this->add_text_field ($defs, 'proxy_port', 'Порт proxy-сервера:', $proxy_port,
                                    true, false, false,  true, null, false, true);
        }

        return $defs;
    }

    private function do_registration_form_defs (&$plugin_cookies)
    {
        $defs = array ();

        $username = isset($plugin_cookies->username) ? $plugin_cookies->username : '';
        $password = isset($plugin_cookies->password) ? $plugin_cookies->password : '';
        $unregister = isset($plugin_cookies->unregister) ? $plugin_cookies->unregister : false;

        $this->add_text_field ($defs, 'username', 'Абонент:', $username,
                                false/*numeric*/, false, false, false, 500);
        $this->add_text_field ($defs, 'password', 'Пароль:', $password,
                                false/*numeric*/, true, false, false, 500);
        $this->add_vgap ($defs, 50);
        $this->add_button ($defs, 'register_terminal', null, 'Регистрация', 400);
        if ($unregister === true) {
            //$this->add_vgap ($defs, -3);
            $this->add_button ($defs, 'unregister_terminal', null, 'Дерегистрация', 400);
        }
        //$this->add_vgap ($defs, -3);
        $this->add_button ($defs, 'register_cancel', null, 'Отменить', 400);

        return $defs;
    }

    private function do_profile_form_defs (&$plugin_cookies, $set_password)
    {
        $defs = array ();

        $this->add_text_field ($defs, 'profile_password', 'Пароль:', '',
                                false/*numeric*/, true, false, false, 500);
        if ($set_password)
            $this->add_text_field ($defs, 'profile_password_repeat', 'Подтверждение пароля:', '',
                                    false/*numeric*/, true, false, false, 500);

        $this->add_vgap ($defs, 50);
        $this->add_button ($defs, $set_password ? 'set_profile_password' : 'verify_profile_password', null, 'Ok', 400);
        $this->add_button ($defs, 'profile_cancel', null, 'Отменить', 400);

        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        //hd_print ('get_control_defs');
        $this->login = $this->tv->login_terminal (null);
        $this->load_profiles ();

        return $this->do_get_control_defs($plugin_cookies);
    }

    public function load_profiles() {
        //hd_print ('load_profiles');
        if ($this->login) {
            $res = $this->tv->api_call (array (
                HD::make_json_rpc_request ('get_terminal_params', array (
                    'macaddr' => str_replace (':', '-', HD::get_mac_addr ())
                )),
                HD::make_json_rpc_request ('get_profiles', array (
                    'macaddr' => str_replace (':', '-', HD::get_mac_addr ())
                ))
            ));
            if ($res && count ($res) == 2 && $res [0]->result && $res [1]->result) {
                $profile_id = $res [0]->result->profile_id;
                $profiles = $res [1]->result;
                $this->profiles = array ();
                foreach ($profiles as $profile) {
                    $this->profiles [$profile->id] = $profile;
                }
                $this->profile = $this->profiles [$profile_id ? $profile_id : 1];
                return true;
            }
        }
        return false;
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print ('handle_user_input');
        foreach ($user_input as $key => $value) {
            hd_print ("  $key => $value");
        }
        if (!isset ($user_input->control_id)/*$user_input->selected_media_url == 'tv_group_list'*/) {
            $this->login = $this->tv->login_terminal (null);
            if (!$this->login)
                return ActionFactory::show_dialog ('Введите регистрационные данные', $this->do_registration_form_defs ($plugin_cookies), true);
            $res = $this->load_profiles ();
            if ($res) {
                if ($this->profile->require_password) {
                    return ActionFactory::show_dialog ('Введите пароль профиля ' . $this->profile->title, $this->do_profile_form_defs ($plugin_cookies, false), true);
                }
                return ActionFactory::open_folder ();
            }
            return;
        } else if ($user_input->action_type == 'confirm' || $user_input->action_type == 'apply' ) {
            $control_id = $user_input->control_id;
            //$new_value = $user_input->{$control_id};
            //hd_print("Setup: changing $control_id value to $new_value");

            if ($control_id == 'show_tv') {
                $plugin_cookies->show_tv = $user_input->show_tv;
            } else if ($control_id == 'use_proxy') {
                $plugin_cookies->use_proxy = $user_input->use_proxy;
                $plugin_cookies->proxy_ip = isset ($plugin_cookies->proxy_ip) ? $plugin_cookies->proxy_ip : '192.168.0.1';
                $plugin_cookies->proxy_port = isset ($plugin_cookies->proxy_port) ? $plugin_cookies->proxy_port : '8080';
            } else if ($control_id == 'proxy_ip') {
                $plugin_cookies->proxy_ip = $user_input->proxy_ip;
            } else if ($control_id == 'proxy_port') {
                $plugin_cookies->proxy_port = $user_input->proxy_port;
            } else if ($control_id == 'register_button') {
                $res = $this->tv->login_terminal (0);
                $plugin_cookies->unregister = $res;
                return ActionFactory::show_dialog ('Введите регистрационные данные', $this->do_registration_form_defs ($plugin_cookies), true);
            } else if ($control_id == 'register_terminal') {
                if (is_null ($user_input->username) || trim ($user_input->username) === '') {
                    return ActionFactory::show_error (false, 'Ошибка', array ('Имя абонента не может быть пустым.'));
                } else if (is_null ($user_input->password) || trim ($user_input->password) === '') {
                    return ActionFactory::show_error (false, 'Ошибка', array ('Пароль не может быть пустым.'));
                }
                $res = $this->tv->register_terminal ($user_input->username, $user_input->password);
                if (!$res)
                    return ActionFactory::show_error (false, 'Ошибка', array ('Неправильное имя абонента или пароль.'));
                $plugin_cookies->username = $user_input->username;
                $plugin_cookies->password = $user_input->password;
                if ($user_input->selected_media_url == 'setup') {
                    return ActionFactory::close_dialog_and_run (ActionFactory::show_title_dialog ('Регистрация выполнена'));
                }
                return ActionFactory::close_dialog_and_run (ActionFactory::open_folder ());
            } else if ($control_id == 'unregister_terminal') {
                $res = $this->tv->unregister_terminal ();
                if ($res && $user_input->selected_media_url == 'setup') {
                    return ActionFactory::close_dialog_and_run (ActionFactory::show_title_dialog ('Дерегистрация выполнена.'));
                }
                return ActionFactory::show_error (false, 'Ошибка', array ('Дерегистрация не выполнена.'));
            } else if ($control_id == 'register_cancel') {
                $res = $this->tv->login_terminal (null);
                if ($res && $user_input->selected_media_url != 'setup') {
                    return ActionFactory::close_dialog_and_run (ActionFactory::open_folder ());
                }
                return ActionFactory::reset_controls ($this->do_registration_form_defs ($plugin_cookies));
            } else if ($control_id == 'profile') {
                $profile = $this->profiles [$user_input->profile];
                if ($profile->require_password) {
                    $this->profile = $profile;
                    return ActionFactory::show_dialog ('Введите пароль профиля ' . $profile->title, $this->do_profile_form_defs ($plugin_cookies, $profile->require_password && !$profile->password), true);
                }
                return;
            } else if ($control_id == 'set_profile_password') {
                if (!$user_input->profile_password)
                    return ActionFactory::show_error (false, 'Ошибка', array ('Пароль не задан.'));
                if ($user_input->profile_password != $user_input->profile_password_repeat)
                    return ActionFactory::show_error (false, 'Ошибка', array ('Пароли не совпадают.'));
                $res = $this->tv->api_call (array (
                    HD::make_json_rpc_request ('set_terminal_params', array (
                        'macaddr' => str_replace (':', '-', HD::get_mac_addr ()),
                        'profile_id' => $this->profile->id
                    )),
                    HD::make_json_rpc_request ('update_profile', array (
                        'macaddr' => str_replace (':', '-', HD::get_mac_addr ()),
                        'profile_id' => $this->profile->id,
                        'profile_password' => $user_input->profile_password
                    ))
                ));
                if ($res && count ($res) == 2 && $res [0]->result && $res [1]->result)
                    return ActionFactory::close_dialog_and_run (ActionFactory::show_title_dialog ('Профиль успешно установлен'));
                return;
            } else if ($control_id == 'verify_profile_password') {
                if ($user_input->profile_password != $this->profile->password)
                    return ActionFactory::show_error (false, 'Ошибка', array ('Неверный пароль.'));
                if ($user_input->selected_media_url != 'setup')
                    return ActionFactory::close_dialog_and_run (ActionFactory::open_folder ());
                $res = $this->tv->set_profile ($this->profile->id);
                if ($res)
                    return ActionFactory::close_dialog_and_run (ActionFactory::show_title_dialog ('Профиль успешно установлен'));
                return;
            } else if ($control_id == 'profile_cancel') {
                $res = $this->tv->set_profile (1);
                if (!$res)
                    return;
                if ($user_input->selected_media_url != 'setup') {
                    return ActionFactory::close_dialog_and_run (ActionFactory::open_folder ());
                }
                $this->profile = $this->profiles [1];
                return ActionFactory::close_dialog_and_run (ActionFactory::show_title_dialog ('Установлен профиль по умолчанию (' . $this->profile->title . ')'));
            }
        }

        return ActionFactory::reset_controls ($this->do_get_control_defs ($plugin_cookies));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
